## MmGdbusModemSignal

MmGdbusModemSignal — Generated C code for the org.freedesktop.ModemManager1.Modem.Signal D-Bus interface

## Functions

guint | mm_gdbus_modem_signal_get_rate ()
gboolean | mm_gdbus_modem_signal_get_error_rate_threshold ()
guint | mm_gdbus_modem_signal_get_rssi_threshold ()
GVariant * | mm_gdbus_modem_signal_get_cdma ()
GVariant * | mm_gdbus_modem_signal_get_evdo ()
GVariant * | mm_gdbus_modem_signal_get_gsm ()
GVariant * | mm_gdbus_modem_signal_get_umts ()
GVariant * | mm_gdbus_modem_signal_get_lte ()
GVariant * | mm_gdbus_modem_signal_get_nr5g ()
GVariant * | mm_gdbus_modem_signal_dup_cdma ()
GVariant * | mm_gdbus_modem_signal_dup_evdo ()
GVariant * | mm_gdbus_modem_signal_dup_gsm ()
GVariant * | mm_gdbus_modem_signal_dup_umts ()
GVariant * | mm_gdbus_modem_signal_dup_lte ()
GVariant * | mm_gdbus_modem_signal_dup_nr5g ()
void | mm_gdbus_modem_signal_call_setup ()
gboolean | mm_gdbus_modem_signal_call_setup_finish ()
gboolean | mm_gdbus_modem_signal_call_setup_sync ()
void | mm_gdbus_modem_signal_call_setup_thresholds ()
gboolean | mm_gdbus_modem_signal_call_setup_thresholds_finish ()
gboolean | mm_gdbus_modem_signal_call_setup_thresholds_sync ()

## Properties

GVariant * | cdma | Read / Write
gboolean | error-rate-threshold | Read / Write
GVariant * | evdo | Read / Write
GVariant * | gsm | Read / Write
GVariant * | lte | Read / Write
GVariant * | nr5g | Read / Write
guint | rate | Read / Write
guint | rssi-threshold | Read / Write
GVariant * | umts | Read / Write

## Signals

gboolean | handle-setup | Run Last
gboolean | handle-setup-thresholds | Run Last

## Types and Values

| MmGdbusModemSignal
struct | MmGdbusModemSignalIface

## Object Hierarchy

        GInterface
        ╰── MmGdbusModemSignal

## Prerequisites

MmGdbusModemSignal requires GObject.

## Known Implementations

MmGdbusModemSignal is implemented by MMModemSignal, MmGdbusModemSignalProxy and MmGdbusModemSignalSkeleton.

## Description

This section contains code for working with the org.freedesktop.ModemManager1.Modem.Signal D-Bus interface in C.

## Functions

### mm_gdbus_modem_signal_get_rate ()

    guint
    mm_gdbus_modem_signal_get_rate (MmGdbusModemSignal *object);

Gets the value of the "Rate" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value.

### mm_gdbus_modem_signal_get_error_rate_threshold ()

    gboolean
    mm_gdbus_modem_signal_get_error_rate_threshold
                                   (MmGdbusModemSignal *object);

Gets the value of the "ErrorRateThreshold" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value.

### mm_gdbus_modem_signal_get_rssi_threshold ()

    guint
    mm_gdbus_modem_signal_get_rssi_threshold
                                   (MmGdbusModemSignal *object);

Gets the value of the "RssiThreshold" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value.

### mm_gdbus_modem_signal_get_cdma ()

    GVariant *
    mm_gdbus_modem_signal_get_cdma (MmGdbusModemSignal *object);

Gets the value of the "Cdma" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_modem_signal_dup_cdma()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_modem_signal_get_evdo ()

    GVariant *
    mm_gdbus_modem_signal_get_evdo (MmGdbusModemSignal *object);

Gets the value of the "Evdo" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_modem_signal_dup_evdo()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_modem_signal_get_gsm ()

    GVariant *
    mm_gdbus_modem_signal_get_gsm (MmGdbusModemSignal *object);

Gets the value of the "Gsm" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_modem_signal_dup_gsm()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_modem_signal_get_umts ()

    GVariant *
    mm_gdbus_modem_signal_get_umts (MmGdbusModemSignal *object);

Gets the value of the "Umts" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_modem_signal_dup_umts()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_modem_signal_get_lte ()

    GVariant *
    mm_gdbus_modem_signal_get_lte (MmGdbusModemSignal *object);

Gets the value of the "Lte" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_modem_signal_dup_lte()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_modem_signal_get_nr5g ()

    GVariant *
    mm_gdbus_modem_signal_get_nr5g (MmGdbusModemSignal *object);

Gets the value of the "Nr5g" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_modem_signal_dup_nr5g()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_modem_signal_dup_cdma ()

    GVariant *
    mm_gdbus_modem_signal_dup_cdma (MmGdbusModemSignal *object);

Gets a copy of the "Cdma" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

### mm_gdbus_modem_signal_dup_evdo ()

    GVariant *
    mm_gdbus_modem_signal_dup_evdo (MmGdbusModemSignal *object);

Gets a copy of the "Evdo" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

### mm_gdbus_modem_signal_dup_gsm ()

    GVariant *
    mm_gdbus_modem_signal_dup_gsm (MmGdbusModemSignal *object);

Gets a copy of the "Gsm" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

### mm_gdbus_modem_signal_dup_umts ()

    GVariant *
    mm_gdbus_modem_signal_dup_umts (MmGdbusModemSignal *object);

Gets a copy of the "Umts" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

### mm_gdbus_modem_signal_dup_lte ()

    GVariant *
    mm_gdbus_modem_signal_dup_lte (MmGdbusModemSignal *object);

Gets a copy of the "Lte" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

### mm_gdbus_modem_signal_dup_nr5g ()

    GVariant *
    mm_gdbus_modem_signal_dup_nr5g (MmGdbusModemSignal *object);

Gets a copy of the "Nr5g" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemSignal. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

### mm_gdbus_modem_signal_call_setup ()

    void
    mm_gdbus_modem_signal_call_setup (MmGdbusModemSignal *proxy,
                                      guint arg_rate,
                                      GCancellable *cancellable,
                                      GAsyncReadyCallback callback,
                                      gpointer user_data);

Asynchronously invokes the `Setup()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_signal_call_setup_finish()` to get the result of the operation.

See `mm_gdbus_modem_signal_call_setup_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemSignalProxy. |
arg_rate | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_signal_call_setup_finish ()

    gboolean
    mm_gdbus_modem_signal_call_setup_finish
                                   (MmGdbusModemSignal *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_signal_call_setup()`.

#### Parameters

proxy | A MmGdbusModemSignalProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_signal_call_setup()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_signal_call_setup_sync ()

    gboolean
    mm_gdbus_modem_signal_call_setup_sync (MmGdbusModemSignal *proxy,
                                           guint arg_rate,
                                           GCancellable *cancellable,
                                           GError **error);

Synchronously invokes the `Setup()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_signal_call_setup()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemSignalProxy. |
arg_rate | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_signal_call_setup_thresholds ()

    void
    mm_gdbus_modem_signal_call_setup_thresholds
                                   (MmGdbusModemSignal *proxy,
                                    GVariant *arg_settings,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `SetupThresholds()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_signal_call_setup_thresholds_finish()` to get the result of the operation.

See `mm_gdbus_modem_signal_call_setup_thresholds_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemSignalProxy. |
arg_settings | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_signal_call_setup_thresholds_finish ()

    gboolean
    mm_gdbus_modem_signal_call_setup_thresholds_finish
                                   (MmGdbusModemSignal *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_signal_call_setup_thresholds()`.

#### Parameters

proxy | A MmGdbusModemSignalProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_signal_call_setup_thresholds()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_signal_call_setup_thresholds_sync ()

    gboolean
    mm_gdbus_modem_signal_call_setup_thresholds_sync
                                   (MmGdbusModemSignal *proxy,
                                    GVariant *arg_settings,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `SetupThresholds()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_signal_call_setup_thresholds()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemSignalProxy. |
arg_settings | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

## Types and Values

### MmGdbusModemSignal

    typedef struct _MmGdbusModemSignal MmGdbusModemSignal;

Abstract interface type for the D-Bus interface org.freedesktop.ModemManager1.Modem.Signal.

### struct MmGdbusModemSignalIface

    struct MmGdbusModemSignalIface {
      GTypeInterface parent_iface;

      gboolean (*handle_setup) (
        MmGdbusModemSignal *object,
        GDBusMethodInvocation *invocation,
        guint arg_rate);

      gboolean (*handle_setup_thresholds) (
        MmGdbusModemSignal *object,
        GDBusMethodInvocation *invocation,
        GVariant *arg_settings);

      GVariant * (*get_cdma) (MmGdbusModemSignal *object);

      gboolean  (*get_error_rate_threshold) (MmGdbusModemSignal *object);

      GVariant * (*get_evdo) (MmGdbusModemSignal *object);

      GVariant * (*get_gsm) (MmGdbusModemSignal *object);

      GVariant * (*get_lte) (MmGdbusModemSignal *object);

      GVariant * (*get_nr5g) (MmGdbusModemSignal *object);

      guint  (*get_rate) (MmGdbusModemSignal *object);

      guint  (*get_rssi_threshold) (MmGdbusModemSignal *object);

      GVariant * (*get_umts) (MmGdbusModemSignal *object);
    };

Virtual table for the D-Bus interface org.freedesktop.ModemManager1.Modem.Signal.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_setup` () | Handler for the “handle-setup” signal. |
`handle_setup_thresholds` () | Handler for the “handle-setup-thresholds” signal. |
`get_cdma` () | Getter for the “cdma” property. |
`get_error_rate_threshold` () | Getter for the “error-rate-threshold” property. |
`get_evdo` () | Getter for the “evdo” property. |
`get_gsm` () | Getter for the “gsm” property. |
`get_lte` () | Getter for the “lte” property. |
`get_nr5g` () | Getter for the “nr5g” property. |
`get_rate` () | Getter for the “rate” property. |
`get_rssi_threshold` () | Getter for the “rssi-threshold” property. |
`get_umts` () | Getter for the “umts” property. |

## Property Details

### The `“cdma”` property

      “cdma”                     GVariant *

Represents the D-Bus property "Cdma".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemSignal

Flags: Read / Write

Allowed values: GVariant<a{sv}>

Default value: NULL

### The `“error-rate-threshold”` property

      “error-rate-threshold”     gboolean

Represents the D-Bus property "ErrorRateThreshold".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemSignal

Flags: Read / Write

Default value: FALSE

### The `“evdo”` property

      “evdo”                     GVariant *

Represents the D-Bus property "Evdo".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemSignal

Flags: Read / Write

Allowed values: GVariant<a{sv}>

Default value: NULL

### The `“gsm”` property

      “gsm”                      GVariant *

Represents the D-Bus property "Gsm".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemSignal

Flags: Read / Write

Allowed values: GVariant<a{sv}>

Default value: NULL

### The `“lte”` property

      “lte”                      GVariant *

Represents the D-Bus property "Lte".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemSignal

Flags: Read / Write

Allowed values: GVariant<a{sv}>

Default value: NULL

### The `“nr5g”` property

      “nr5g”                     GVariant *

Represents the D-Bus property "Nr5g".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemSignal

Flags: Read / Write

Allowed values: GVariant<a{sv}>

Default value: NULL

### The `“rate”` property

      “rate”                     guint

Represents the D-Bus property "Rate".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemSignal

Flags: Read / Write

Default value: 0

### The `“rssi-threshold”` property

      “rssi-threshold”           guint

Represents the D-Bus property "RssiThreshold".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemSignal

Flags: Read / Write

Default value: 0

### The `“umts”` property

      “umts”                     GVariant *

Represents the D-Bus property "Umts".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemSignal

Flags: Read / Write

Allowed values: GVariant<a{sv}>

Default value: NULL

## Signal Details

### The `“handle-setup”` signal

    gboolean
    user_function (MmGdbusModemSignal    *object,
                   GDBusMethodInvocation *invocation,
                   guint                  arg_rate,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Setup()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_signal_complete_setup()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemSignal. |
invocation | A GDBusMethodInvocation. |
arg_rate | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-setup-thresholds”` signal

    gboolean
    user_function (MmGdbusModemSignal    *object,
                   GDBusMethodInvocation *invocation,
                   GVariant              *arg_settings,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `SetupThresholds()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_signal_complete_setup_thresholds()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no other signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemSignal. |
invocation | A GDBusMethodInvocation. |
arg_settings | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`G_DBUS_METHOD_INVOCATION_HANDLED` or `TRUE` if the invocation was handled, `G_DBUS_METHOD_INVOCATION_UNHANDLED` or `FALSE` to let other signal handlers run.

Flags: Run Last